--[[
	##AddOn	: CooldownIcons R(evamped)
	##Subfile 	: timer.lua
	##Author  : Hati ( xhatix on wowace.com )
--]]
local CIR = CooldownIconsR
local tinsert = tinsert
local tremove = tremove
local tContains = _G.tContains
local GetTime = _G.GetTime
local LCI = LibStub("LibCooldownIcons") -- extended lua lib 
local function CooldownByCmd(watch,wtype)
	if wtype=='spell' then
		return GetSpellCooldown(watch)
	else
		return GetItemCooldown(watch)
	end
end
local icondb
CIR.OnCooldown = { }
--start Table
local startT= { }
--duration Table
local durationT = { }

function CIR:wipeCDTables()
    for k,v in pairs(startT) do
        startT[k] = 0
        durationT[k] = 0
    end
end

function CIR:wipeCDEntry(entry)
    durationT[entry]=0
    startT[entry]=0
end
function CIR:wipeDurationEntry(entry)
    durationT[entry]=0
end
function CIR:wipeStartEntry(entry)
    startT[entry]=0
end

--db stores
local gcdFix
local exLagTol
local StartRecOffset


--[[
Hooking GetSpellCooldown in order to achieve 100% accurate cooldowns
]]
local resetOn = {
    --Spell = Buff
    --[23922] = 50227
    --id's so it's localized
    [23922] = 50227
}

local function GetSpellID(name)
    if not name then return end
    if type(name)=="number" then
        return name
    else
        local v = GetSpellLink(name)
        if v then
            return (select(3,string.find(tostring(v),"Hspell:(%d+)")))
        end
    end
end

local function GetIconsWatching(spell)
    local t = { }
    for icon,obj in pairs(CIR.icons) do
        if obj.active then 
            if spell==obj.watch then
                tinsert(t,icon)
            end
        end
    end
    return t
end

local GetSpellCooldownFix=function(...)
    local spell = ...
    if spell then
        local id = tonumber(GetSpellID(spell) or 0)
        local isBuff = resetOn[id]
        --print(id,isBuff)
        if isBuff and UnitAura("player",GetSpellInfo(isBuff)) then
            local name = GetSpellInfo(id)
            local toStop = GetIconsWatching(name)
            for i,obj in ipairs(toStop) do
                --[[tDeleteItem(CIR.OnCooldown,obj)
                CIR.icons[obj].text:SetText("")
                CIR.icons[obj]:SetDisplay(false)]]
                startT[obj]=0
                durationT[obj]=0
            end
            return 0,0,0
        end
    end
end

hooksecurefunc("GetSpellCooldown",GetSpellCooldownFix)

function CIR:SPELL_ACTIVATION_OVERLAY_SHOW()
    for icon,t in pairs(CIR.icons) do
        if t.type == 'spell' then
            GetSpellCooldownFix(t.watch)
        end
    end
end

function CIR:SPELL_UPDATE_COOLDOWN(event)
	if not icondb then
		icondb = CIR.db.char.icondb
	end
	if not self.OnCooldown then
		self.OnCooldown={}
	end
	gcdFix = CIR.db.char.gMisc.gFixGCD
    exLagTol = CIR.db.char.gMisc.gLagTolerance
    if exLagTol then
        SetCVar("reducedLagTolerance",1)
        StartRecOffset=(tonumber(GetCVar("maxSpellStartRecoveryoffset")) or 0)/1000
    end
	for obj,t in pairs(self.icons) do
		if t.active then
            if not exLagTol then
                if not durationT[obj] then durationT[obj]=0 end
                if not startT[obj] then startT[obj]=0 end
                --print(tContains(self.events[event],obj))
                if self.events[event] then
                    if tContains(self.events[event],obj) then
                        local script = self.db.char.icondb[obj].script
                        self:ProcessScriptForIcon(script,t)
                    end
                end
                local watch,wtype = t.watch, t.type
                if watch and wt~="disabled" then
                    local isRunningCooldown = tContains(self.OnCooldown,obj)
                    local start,duration = CooldownByCmd(watch,wtype)
                    if start and duration then
                        if start==0 or duration==0 then
                            durationT[obj]=0
                            startT[obj]=0
                            t.text:SetText("")
                            t:SetDisplay(false)
                            if not CIR.icons[obj].forcedgray then
                                CIR.icons[obj].texture:SetDesaturated(0)
                            end
                            tDeleteItem(CIR.OnCooldown,obj)
                        elseif gcdFix and duration>1.5 then
                            startT[obj]=start
                            durationT[obj]=duration
                            if icondb[obj].iGrayscale and not t.forcedgray then
                                t.texture:SetDesaturated(1)
                            end
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        elseif not gcdFix then
                            startT[obj]=start
                            durationT[obj]=duration
                            if icondb[obj].iGrayscale and not t.forcedgray then
                                t.texture:SetDesaturated(1)
                            end
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        end
                    end
                end
            else --exLagTol
                if not durationT[obj] then durationT[obj]=0 end
                if not startT[obj] then startT[obj]=0 end
                --print(tContains(self.events[event],obj))
                if self.events[event] then
                    if tContains(self.events[event],obj) then
                        local script = self.db.char.icondb[obj].script
                        self:ProcessScriptForIcon(script,t)
                    end
                end
                local watch,wtype = t.watch, t.type
                if watch and wt~="disabled" then
                    local isRunningCooldown = tContains(self.OnCooldown,obj)
                    local start,duration = CooldownByCmd(watch,wtype)
                    if start and duration then
                        if start==0 or duration==0 then
                            durationT[obj]=0
                            startT[obj]=0
                            t.text:SetText("")
                            t:SetDisplay(false)
                            if not CIR.icons[obj].forcedgray then
                                CIR.icons[obj].texture:SetDesaturated(0)
                            end
                            tDeleteItem(CIR.OnCooldown,obj)
                        elseif gcdFix and duration>1.5 then
                            startT[obj]=start
                            durationT[obj]=duration-StartRecOffset
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                if icondb[obj].iGrayscale and not t.forcedgray then
                                    t.texture:SetDesaturated(1)
                                end
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        elseif not gcdFix then
                            startT[obj]=start
                            durationT[obj]=duration-StartRecOffset
                            if not isRunningCooldown then
                                tinsert(self.OnCooldown,obj)
                                if icondb[obj].iGrayscale and not t.forcedgray then
                                    t.texture:SetDesaturated(1)
                                end
                                t:SetDisplay(true)
                                t:SetTime(startT[obj],durationT[obj])
                            end
                        end
                    end
                end
            end
		end
	end
end

local threads={
	0, 0,
	0, 0,
	0,
}
local function updaterFunc(self, elapsed)
	if not CIR.updateFrequency then return end
	if not self.lastUpdate then
		self.lastUpdate = 0
	end
	self.lastUpdate = self.lastUpdate+elapsed
	while(self.lastUpdate >= CIR.updateFrequency and #threads>0) do
        --print(GetSpellCooldown("Shield Slam"))
		if tremove(threads,1) then --4 ingame hmm
            if exLagTol then
                SetCVar("reducedLagTolerance",1)
                StartRecOffset=(tonumber(GetCVar("maxSpellStartRecoveryoffset")) or 0)/1000
            end
            CIR.updaterOnCD = CIR.OnCooldown
            local event = "CIR_GETTIME"
			for num,obj in ipairs(CIR.updaterOnCD) do
				local icon = CIR.icons[obj]
                local start, duration = CooldownByCmd(icon.watch,icon.type)
                --CIR_GETTIME module
                if CIR.events[event] then
                    if tContains(CIR.events[event],obj) then
                        local script = CIR.db.char.icondb[obj].script
                        CIR:ProcessScriptForIcon(script,icon)
                    end
                end
                --/CIR_GETTIME module
                --Cooldown Module
				if GetTime() >= (startT[obj]+durationT[obj]) or (start==0 and duration==0) then
                    startT[obj]=0
                    durationT[obj]=0
					if not icon.forcedgray then
						icon.texture:SetDesaturated(0)
					end
					icon:SetDisplay(false)
					icon.text:SetText("")
					tremove(CIR.OnCooldown,num)
					--self.lastUpdate=self.lastUpdate-CIR.updateFrequency
					
				else
                    if icondb[obj].iGrayscale and not icon.forcedgray then
                        icon.texture:SetDesaturated(1)
                    end
					if gcdFix then
						if (durationT[obj] == duration or duration==0) then
                            if not exLogTol then
                                durationT[obj]=duration
                            else
                                durationT[obj]=duration-StartRecOffset
                            end
						end
						if (startT[obj] > start and (start ~= GetTime() or duration>1.5) )  then
							startT[obj]=start
						end
					else
                        if not exLogTol then
                            durationT[obj]=duration
                        else
                            durationT[obj]=duration-StartRecOffset
                        end
						startT[obj]=start
					end
		--			local start,duration = CooldownByCmd(icon.watch,icon.type)
					--if GetTime()<(startT[obj]+durationT[obj])  then
						icon:SetDisplay(true)
						icon:SetTime(startT[obj],durationT[obj])
		--[[			elseif GetTime() >= (startT[obj]+durationT[obj]) then
						if not icon.forcedgray then
							icon.texture:SetDesaturated(0)
						end
						icon:SetDisplay(false)
						icon.text:SetText("")
						tremove(CIR.OnCooldown, num)
		]]
                end
                --/Cooldown Module
            end
			tinsert(threads,0)
        end
		self.lastUpdate = self.lastUpdate - CIR.updateFrequency
	end
end

local updater = CreateFrame("Frame","CIR_Updater",UIParent)
updater:SetScript("OnUpdate",updaterFunc)


